#include <cstring>
#include <iostream>
#include <map>
#include <string>
#include <vector>
#include <experimental/iterator>

std::vector<std::string> split(std::string linea, const char* delim)
{
   std::vector<std::string> res;
   for (auto t = std::strtok(&linea[0], delim); t != nullptr; t = std::strtok(nullptr, delim)) {
      res.push_back(t);
   }

   return res;
}

struct nodo {
   virtual std::string evalua(const std::vector<std::string>& fila) = 0;
   virtual void imprime(std::ostream&) = 0;
};

struct nodo_hoja : nodo {
   std::string valor;

   std::string evalua(const std::vector<std::string>& fila)
   {
      return valor;
   }

   void imprime(std::ostream& os)
   {
      os << valor;
   }
};

struct nodo_interno : nodo {
   std::pair<std::string, int> variable;
   std::map<std::string, nodo*> ramas;

   std::string evalua(const std::vector<std::string>& fila)
   {
      auto r = ramas.find(fila[variable.second]);
      return (r == ramas.end( ) || r->second == nullptr ? "?" : r->second->evalua(fila));
   }

   void imprime(std::ostream& os)
   {
      os << variable.first << " (\n";
      for (const auto& r : ramas) {
         os << r.first << " => \n";
         if (r.second) {
            r.second->imprime(os);
            os << '\n';
         } else {
            os << "?\n";
         }
      }
      os << ")\n";
   }
};

nodo* construye_arbol(std::vector<std::vector<std::string>>& filas, const std::map<std::string, int> columnas& columnas, std::set<int>& faltantes)
{
   if (filas.empty( )) {
      return nullptr;
   }

   auto clase = columnas["clase"];
   if (faltantes.empty( )) {
      std::map<
   }
}

nodo* construye_arbol(std::vector<std::vector<std::string>> filas, const std::map<std::string, int> columnas& columnas)
{
   std::set<int> faltantes;
   for (int i = 0; i < columnas.size( ); ++i) {
      faltantes.insert(i);
   }
   faltantes.erase(columnas["clase"]);

   return construye_arbol(filas, columnas, faltantes);
}

int main( )
{
   std::vector<std::vector<std::string>> filas;
   for (std::string linea; std::getline(std::cin, linea); ) {
      filas.push_back(split(linea, ","));
   }

   std::map<std::string, int> columnas;
   for (int i = 0; i < filas[0].size( ); ++i) {
      columnas.emplace(filas[0][i], i);
   }

   std::swap(filas.front( ), filas.back( ));
   filas.pop_back( );
}
